Arch Roof

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Arch Roof and the translation is 5% complete.

Outdated translations are marked like this.
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎português do Brasil • ‎română • ‎русский • ‎svenska • ‎українська
Arrow-left.svg Previous: Arch Grid.svg Grid
Next: Space Arch Space.svg Arrow-right.svg

Arch Roof.svg Arch Roof

Veja também
Arch → Roof
Bancadas de trabalho
Arch
Atalho padrão
R F
Veja também
None


Description

The Roof tool allows you to create a sloped roof from a selected wire. The created roof object is parametric, keeping its relationship with the base object. The principle is that each edge is seen allotting a profile of roof (slope, width, overhang, thickness).

This tool is still in development, and might fail with very complex shapes.

RoofExample.png

RoofExample.png

How to use

  1. Create a wire with following the counterclockwise direction and select it.
    • CounterclockwiseWire.png
  2. Press the Arch Roof.svg Arch Roof button, or press R then F keys
  3. The default roof object could have a strange shape, it's because the tool have not all the needed informations.
  4. After creating the default roof, double click on the object in the tree view to access and edit all the properties. Angle must be between 0 and 90.
    • RoofTable.png
  5. Each line correspond to a roof pane. So you can set properties you want for each roof pane.
  6. To help you, you can set Angle or Run to 0 and defined a Relative Id, this make automatic calculs to find the data relative to the relative Id.
  7. It work like this :
    1. If Angle = 0 and Run = 0 then profile is identical to the relative profile.
    2. If Angle = 0 then angle is calculated so that the height is the same one as the relative profile.
    3. If Run = 0 then Run is calculated so that the height is the same one as the relative profile.
  8. At the end, set an angle to 90° to make a gable.
    • RoofProfil.png
  9. Also you can check this video : https://www.youtube.com/watch?v=4Urwru71dVk

Options

Properties

  • DATAAngles: List of the slope angle of the roof pane (an angle for each edge in the wire).
  • DATARuns: List of the width of the roof pane (a run for each edge in the wire).
  • DATAIdRel: List of relation Id The slope angle of the roof
  • DATAThickness: List of thickness of the roof pane. (a thickness for each edge in the wire).
  • DATAOverhang: List of the overhang of the roof pane (an overhang for each edge in the wire).
  • DATAFace: The face index of the base object to be used #Not really used

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Roof tool can be used in macros and from the Python console by using the following function:

Roof = makeRoof(baseobj=None, facenr=0, angles=[45.,], run=[], idrel=[0,], thickness=[50.,], overhang=[100.,], name="Roof")
  • Creates a Roof object from the given baseobj, which can be a closed wire or a solid object.
    • If baseobj is a wire, you can provide lists for angles, run, idrel, thickness, and overhang, for each edge in the wire to define the shape of the roof.
    • The lists are automatically completed to match the number of edges in the wire.

Example:

import FreeCAD, Arch, Draft

Rect = Draft.makeRectangle(3000, 4000)
Roof = Arch.makeRoof(Rect, angles=[30.,])
FreeCAD.ActiveDocument.recompute()

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1000, 1000, 0)
p3 = FreeCAD.Vector(0, 2000, 0)
Wire = Draft.makeWire([p1, p2, p3], closed=True)
Roof2 = Arch.makeRoof(Wire)
FreeCAD.ActiveDocument.recompute()